//-----------------------------------------------------------------------------
// NtfsSysFiles
// Author:  DLang   2009 
//-----------------------------------------------------------------------------

#include <iostream>
#include <iomanip>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <io.h>

using  namespace std;

#include <windows.h>
#include <winioctl.h>

//-----------------------------------------------------------------------------
static char* ShowError(void) 
{ 
    static char szReturn[128] = {0};
    char *lpMsgBuf; 
    FormatMessage( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, 
        NULL, 
        GetLastError(), 
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), 
        (LPTSTR) &lpMsgBuf, 
        0, 
        NULL 
        ); 
    memset(szReturn,0,  sizeof szReturn);
    strcpy(szReturn, lpMsgBuf);
    LocalFree( lpMsgBuf ); 
    return (char *) szReturn;
}


/*
    NTFS special files:

    $AttrDef
    $BadClus
    $BadClus:$Bad
    $BitMap
    $Boot
    $LogFile
    $Mft
    $MftMirr
    $Secure
    $UpCase
    $Volume
    $Extend
    $Extend\$Reparse
    $Extend\$ObjId
    $Extend\$UsnJrnl
    $Extend\$UsnJrnl:$Max
    $Extend\$Quota

*/


/*
 Registry special files:

 user.dat and system.dat

 doc\<user>\Local Settings\Application Data\Microsoft\Windows\UsrClass.dat
 doc\<user>\NtUser.dat
 doc\LocalService\Local Settings\Application Data\Microsoft\Windows\UsrClass.dat
 doc\LocalService\NtUser.dat
 doc\NetworkService\Local Settings\Application Data\Microsoft\Windows\UsrClass.dat
 doc\NetworkService\NtUser.dat

 c:\windows\system32\config\default
 c:\windows\system32\config\SAM
 c:\windows\system32\config\SECUIRTY
 c:\windows\system32\config\software
 c:\windows\system32\config\system

 */

extern int FileAllocation(const char* szFileName);

// Display allocation map for MFT file
bool NtfsSysFiles()
{
    const char filename[] = "c:\\$Mft";

    FileAllocation(filename);

#if 0
    HANDLE hFile;
    hFile = CreateFile(filename,  0,                    7, 0, OPEN_EXISTING, FILE_READ_ATTRIBUTES, 0);
#endif

    return true;
}